Cutlass.generateAllHTML = function(){
  Cutlass.generateHTML(['text', 'text--large', 'select', 'select--large', 'radio', 'toggler', 'toggler--reverse', 'link'])
}

Cutlass.generateHTML = function(inputTypes){
  $.each(inputTypes, function(i, inputType){
    $('.Cutlass-input-' + inputType).each(function(){
      Cutlass.wrapInItem($(this), 'm-' + inputType)
      Cutlass.addLabel($(this))
      Cutlass.addDescription($(this))
      Cutlass.addError($(this))
      Cutlass.addWrapperClasses($(this))
      Cutlass.ifAlwaysActive($(this))
    })
  })
  Cutlass.addFlag();
}

// HELPERS =====================
Cutlass.wrapInItem = function($el, cssClass){
  $el.closest('.input').addClass('Cutlass-item ' + cssClass);
  // var $div = $('<div class="Cutlass-item ' + cssClass + '"></div>');
  // $el.before($div)
  // var $input = $el.detach();
  // $div.append($input)
}
Cutlass.addLabel = function($input){
  // // var text = $input.data('label');
  // var $label = $input.closest('.Cutlass-item').find('.Cutlass-label');
  // console.log('label', $label);
  // if($label.hasClass('outside-label')) {
  //   console.log('ahh');
  //   // $input.before($label)
  //   // $label.remove()
  // } else {
  //   console.log('err');
  // }
}
Cutlass.addDescription = function($input){
  var desc = $input.data('description');
  if(desc){
    var $desc = $('<div class="Cutlass-description">' + desc + '</div>')
    $input.siblings('.Cutlass-label').append($desc)
  }
}
Cutlass.addError = function($input){
  var text = $input.data('error');
  var $error = $input.closest('.input').next('.cutlass_error');
  $error.remove();
  if($error.find('.Cutlass-error').html() && $error.find('.Cutlass-error').html().length > 0) {
    $input.before($error);
  }
}
Cutlass.removeError = function($input){
  $input.siblings('.Cutlass-error').remove();
}
Cutlass.addWrapperClasses = function($input){
  var classes = $input.data('wrapper-classes');
  if(classes){
    classes = classes.split(' ');
    classes.forEach(function(klass){
      $input.closest('.input').addClass(klass)
    })
  }
}
Cutlass.ifAlwaysActive = function($input){
  if($input.data('always-active')){
    $input.closest('.input').addClass('m-always-active')
  }
}
Cutlass.addFlag = function(){
  $('.Cutlass-item').eq(0).attr('data-cutlassed', true);
}
Cutlass.hasntRun= function(){
  return !$('[data-cutlassed]').length
}
